# List Workspaces

> Source: https://truto.one/docs/api-reference/unified-user-directory-api/workspaces/list/

`GET /unified/user-directory/workspaces`

Resource: **Workspaces** · API: **Unified User Directory API**

## Supported integrations

Adobe Marketo Engage, Adyen, Aha (partial), Anthropic, Asana, Atlassian, Avalara AvaTax, Bitbucket (partial), Cisco Meraki, Contentful Content Management, dbt Labs, Discord, Doppler, Freshservice, Google CloudSQL, GitLab, Gong, Google, Google Ads, Google Cloud, Hashicorp Terraform Cloud, Height, Highlevel, Illow, Jenkins, Lemlist, ManageEngine ServiceDesk Plus, Microsoft 365, Monday.com, MongoDB Atlas Admin, mParticle, Microsoft Teams, Mural, Pivotal Tracker, Podio (partial), Power BI, Render, Segment, SharePoint, Sigma Computing, Slack Enterprise, SonarQube Server, Teamwork Project Management, Teamwork Spaces, Typeform, Vercel, Webflow, WordPress, Workiva, Zeplin, Zesty.io, Zoho BugTracker, Zoho Projects, Zoho Sprints

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_key_by`** _(string)_
  By default the `result` attribute is an array of objects. This parameter allows you to specify a field in each `result` objects to use as key, which transforms the `result` array into an object with the array items keyed by the field. This is useful for when you want to use the result as a lookup table.
- **`truto_ignore_limit`** _(boolean)_
  Ignores the `limit` query parameter.
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`updated_at`** _(string)_
  Date and time when the workspace was last updated.
- **`organization_id`** _(string)_
- **`group_id`** _(string)_
  Either of organization_id or group_id is required.
- **`status`** _(string)_
  Status for the workspace
  Allowed: `active`, `inactive`
- **`name`** _(string)_
  Name of the workspace.
- **`description`** _(string)_
  Description for the workspace.
- **`sort_by`** _(string)_
  Allowed: `created_at`, `name`, `updated_at`
- **`workspace_id`** _(string)_
  When set with include_nested=true, returns all descendants of this parent group
- **`include_nested`** _(boolean)_
  Set to true to return all descendant groups (direct and indirect) of the group specified by workspace_id.
- **`product`** _(string)_
  Allowed: `analytics`, `sharepoint`, `teams`

## Response body

- **`result`** _(array<object>)_
  List of Workspaces
  - **`id`** _(string, required)_
    Unique identifier for the workspace.
  - **`name`** _(string)_
    Name of the workspace.
  - **`description`** _(string)_
    Description for the workspace.
  - **`status`** _(string)_
    Status for the workspace
    Allowed: `active`, `inactive`
  - **`created_at`** _(string)_
    Date and time when the workspace was created.
  - **`updated_at`** _(string)_
    Date and time when the workspace was last updated.
  - **`organization`** _(object)_
    organization associated with the workspace
    - **`id`** _(string)_
      The unique identifier for an organization
    - **`name`** _(string)_
      The name of the organization
  - **`remote_data`** _(object)_
    Raw data returned from the remote API call.
- **`next_cursor`** _(string)_
  The cursor to use for the next page of results. Pass this value as `next_cursor` in the query parameter in the next request to get the next page of results.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/user-directory/workspaces?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/user-directory/workspaces?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/user-directory/workspaces"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.list(
  'user-directory',
  'workspaces',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    async for item in truto_api.unified_api.list(
        "user-directory",
        "workspaces",
        {"integrated_account_id": "<integrated_account_id>"}
    ):
        print(item)

asyncio.run(main())
```
